#ifndef ds50daq_DAQ_CompositeDriver_hh
#define ds50daq_DAQ_CompositeDriver_hh

#include "fhiclcpp/fwd.h"
#include "artdaq/DAQdata/Fragments.hh"
#include "DS50FragmentGenerator.hh"
#include <vector>

namespace ds50 {
  // CompositeDriver handles a set of lower-level generators
  class CompositeDriver : public DS50FragmentGenerator {
    public:
      explicit CompositeDriver(fhicl::ParameterSet const &);
      virtual ~CompositeDriver() noexcept;

    private:
      void start_ () override;
      void stop_ () override;
      void pause_ () override;
      void resume_ () override;
      void shutdown_ () override;
      std::vector<artdaq::Fragment::fragment_id_t> fragmentIDs_() override;
      bool getNext__(artdaq::FragmentPtrs & output) override;

      bool makeChildGenerator_(fhicl::ParameterSet const &);

      std::vector<std::unique_ptr<DS50FragmentGenerator>> generator_list_;
      std::vector<bool> generator_active_list_;

  };
}
#endif /* ds50daq_DAQ_CompositeDriver_hh */
